// --------------------------------------------------------
// textXMail
// Fev 2001
// --------------------------------------------------------

/*  

  Deux versions:

  textGPXmail qui convertit GlossPost syntax  XMail
  textXMail   qui convertit XMail syntax  XML

textGPXmail()
  Entre un message texte 
  Sort un wxArray 

textGPDXmail()
  Entre un digest de messages
  Sort un wxArray 


wxFile
*/

#include <c_defs.h>
#include <c_link.h>
#include <c_String.h>
#include <c_File.h>


/* Lecture de string XMail dans une arborescence
*/
bool GPostFile2XML (c_Str& szFile, c_Str& szValue);  // depuis fichier
bool GPostStr2XML  (c_Str& szValue);                  // depuis chaine


/*---------------------------------------------------------------*/
//  Arborescence XML drived de c_Node/c_Link
/*---------------------------------------------------------------*/

int gIX=0; 

class c_xmlNode: public c_Node
{
public:
  c_Str tag;
  c_Str data;

  ~c_xmlNode()
  {
     gIX++;
  }
  virtual bool IsValid() { return true; }

  bool node2xml(c_Str* szBuffer, int mode )
    {
    c_Str szTemp;
      size_t buflen;
      switch(mode)
      {
      case 1:
        buflen= tag.size() + 10;
        szTemp.appendf( buflen, "\n<%s>", tag.c_str());
        break;
      case 2:
        buflen= 2* tag.size() + data.size() + 10;
        szTemp.printf( buflen, "\n<%s>%s\n</%s>", 
          tag.c_str(), 
          data.c_str(), 
          tag.c_str());
        break;
      case 3:
        buflen= tag.size() + 10;
        szTemp.printf( buflen, "\n</%s>", tag.c_str());
        break;
      }
      szBuffer->append (szTemp);
      return true;
    }
};


class c_xmlLink: public c_Link
{
private:
  c_Str* m_xmlBuffer; 
      
public:

  bool Write(c_Str& szBuffer );
  bool Read (c_Str& szdata);

  virtual bool EventParse(c_Node* pnode);
};

bool c_xmlLink::EventParse(c_Node* pnode) 
  { 
    if( !pnode->Parent() ) return true; 

    if( pnode->IsFirstSibling())
      ((c_xmlNode*)pnode->Parent())->node2xml(m_xmlBuffer,1);

    ((c_xmlNode*)pnode)->node2xml(m_xmlBuffer,2);

    if( pnode->IsLastSibling())
      ((c_xmlNode*)pnode->Parent())->node2xml(m_xmlBuffer,3);

    return true;      // continuer !!
  }

/*
  Lecture de chaine au format XMAIL
*/
bool c_xmlLink::Read(c_Str& szValue)
{
  return true;
}

/*  
  Formatter l'arborescence dans une chaine 
*/

bool c_xmlLink::Write(c_Str& szBuffer )
{ 
  m_xmlBuffer= &szBuffer;
  m_xmlBuffer->resize(0);

  // Supprimer les NL
  size_t pos;
  while( C_STR_NPOS!= (pos= m_xmlBuffer->find(NL, pos)))
    m_xmlBuffer->erase(pos,1);

  ParseTree();

  (*m_xmlBuffer) << NL;

  return true;
}


// --------------------------------------------------------
/*  GPPrepare( c_Str&)
/*---------------------------------------------------------------*/

/*
GPPreapre( c_Str&)
  Entre:  1 ou plusieurs messages au format GP
  Sort:   la mme chaine au format XMail
  return: true si des substitutions ont eu lieu

  Message:      <message>
  Date:         <1 date>
  From:         <1 from>
  Subject:      <1 subject>

  url:          <2 url>
  lang:         <1 lang>
  src:          <2 src>
  kwd:          <2 kwd>
  cmt:          <2 cmt>
  ***           </message>

 La conversion est:
  \n_URL_:     \n_tag1_:      \n_tag2_:     \n_***
  <GP><URL> <tag1>      <tag2>     </GP>
*/


static bool _GPPrepare  (c_Str& szValue);
static bool _GP2xmlLink (c_xmlLink& xmlLink, c_Str& szValue);

enum
{
  GPDATE    =0    // une ligne
, GPFROM
, GPSUBJECT   

, GPURL       // multiline
, GPLANG
, GPSCR       // multiline
, GPCMT 
, GPKWD       // multiline

, GPMESSAGE   // Blocs
, GPEND
, GPsize
};
static lpcstr GPNames[GPsize]=
{  "DATE:","From:","Subject:",
   "URL:","LANG:","SRC:","KWD:", "CMT:",
   "MESSAGE:","***"};
static lpcstr GPSubst[GPsize]=
{  "<1 DATE>","<1 FROM>","<1 SUBJECT>",
   "<2 URL>","<1 LANG>","<2 SRC>","<2 KWD>","<2 CMT>",
   "<UNIT>","</UNIT>"};


/* 
  Conversion prparatoire des tokens GP 
*/
static bool _GPPrepare(c_Str& szValue)
// 
{
size_t pos,end;
size_t counter;
bool ret= false;     

#if 0
  // Substitution des entits (htmlencode())
  pos = 0;
  while( C_STR_NPOS!= (pos= szValue.find_first_of("<>", pos)))
  {
    szValue.replace( pos, 1, '<' == szValue[pos] ? "&lt;" : "&gt;" );    // substitution
  }
#endif 

  // Substitution URL---*** 
  for( counter=GPDATE; counter < GPsize; counter++)
  {
    pos=0; 
    while( C_STR_NPOS!= (pos= szValue.findtag(pos, GPNames[counter])))
    {
      end= pos + strlen( GPNames[counter]);
      szValue.replace( pos, end-pos, GPSubst[counter]);    // substitution
      pos+= strlen( GPSubst[counter]);      // a la suite de substitution
      ret= true;                              // au moins une substitution
    }
  }
  return ret; // indique si des substitutions ont eu lieu
}


/* 
  Initialise xmlLink  partir de chaine GPost
*/
bool _GP2xmlLink (c_xmlLink& xmlLink, c_Str& szValue)
{
size_t bkpos, bkend, bkalt;
size_t pos, end;
c_xmlNode *parentBk, *childBk;
c_Str  szBlock;
    

  _GPPrepare( szValue);      // Analyse finie des tags
  xmlLink.Clear();

  // recherche de blocs <UNIT>. Ignore PCdata 
  // Les blocs corrects sont dtects   comme <UNIT> .. </UNIT> .. <UNIT> 
  // Les blocs incorrects sont dtects comme <UNIT> .. <UNIT> .. </UNIT>
  bkpos= 0;

  while( C_STR_NPOS!= (bkpos= szValue.findtag(bkpos, "<UNIT>")))
  {

    // Dgager un bloc correct 
    bkpos+= 6;   // len(<UNIT>
    bkend = szValue.find("</UNIT>", bkpos); // C_STR_NPOS si !found
    bkalt = szValue.find("<UNIT>", bkpos);  // C_STR_NPOS si !found
    
    if( bkend > bkalt )         // syntaxe incorrecte ?
      continue;                 

    szBlock= szValue.substr( bkpos, bkend-bkpos);   

    // Installer le bloc parent sur root
    parentBk= new c_xmlNode; 
    parentBk->tag = "UNIT"; 

    xmlLink.Sync();
    xmlLink.Add( parentBk);
     
    // Analyse du childBlock: lignes simples

    pos = 0;
    while( C_STR_NPOS!= (pos= szBlock.findtag(pos, "<1 ")))
    {

      childBk= new c_xmlNode; 

      // Lire le tag
      pos+=3;
      end= szBlock.find     ( RTAG, pos);      // lire le tag
      childBk->tag= szBlock.substr   ( pos, end-pos);   // conserve le TAG

      // lire les donnes 
      pos= end+1;
      end= szBlock.find     ( NL, pos);      // Chercher NL
      childBk->data= szBlock.substr( pos, end-pos);   // conserve pcdata
      childBk->data.trim();

      // append aux childs du parent node
      xmlLink.AddChild(parentBk, childBk);

    }

    // Analyse du childBlock: multilignes 

    pos= 0;
    while( C_STR_NPOS!= (pos= szBlock.findtag(pos, "<2 ")))
    {

      childBk = new c_xmlNode; 
      
      // lire le tag
      pos+=3;
      end= szBlock.find     ( RTAG, pos);      // lire le tag
      childBk->tag = szBlock.substr   ( pos, end-pos);   // conserve le TAG

      // lire les donnes 
      pos= end+1;
      end= szBlock.find     ( LTAG, pos);                // Chercher TAG suivant 
      childBk->data = szBlock.substr( pos, end-pos);   // conserve pcdata
      childBk->data.trim();

      // append aux childs du parent node
      xmlLink.AddChild(parentBk, childBk);
    }

  }
  return true;
}

/*
  extern fonctions
*/

bool GPostStr2XML (c_Str& data)
{
c_xmlLink xmlLink; 
  _GP2xmlLink (xmlLink, data);   // stocker GP dans xmlLink
  xmlLink.Write( data);          // dump dans la mme chaine!
  return true;
}

bool GPostFile2XML (c_Str& szfile, c_Str& data)
{
c_File fp;
size_t count; 

  if( !c_fexists(szfile)) return false;  

  // lecture du fichier en substituant LT/GT
  fp.open(szfile);
  count= fp.length(); 
  data.reserve(count+(count>>8)); // reserver GT/LT
  fp.read(data, count);
  fp.close();

  data.htmlencode( C_HTMLSTRICT|C_HTMLPACK);

  GPostStr2XML(data);    // traiter en mmoire

  fp.open("out.xml", "wt");

  fp.putstrnl("<?xml version='1.0' encoding='iso-8859-1' ?>") ;
  fp.putstrnl( "<glosspost>"); 
  fp.write( data);
  fp.putstrnl( "</glosspost>"); 
  fp.close();

  return true;


}


