/*****************************************************
  file    : c_ascii.h
  usage   : codes ASCII d'usage general
  date    : 1991 -- 
  copyleft: I.R.Maturana <irm@in3activa.com>
  autres  :
  licence : gnu - see www.gnu.org/copyleft/gpl.html
 *****************************************************/

/*************************************/
/*  ascii.hpp   
/*  Nomenclature des codes
/*************************************/

#ifndef _C_ASCII_H_
#define _C_ASCII_H_

#define     KByte    1024
#define     Kbyte    KByte
#define     Kb	     KByte
#define     CTRL(n)  ((n)&'\x1F')

/*[1] Nomenclature ASCII standart: (cf Joe Campbell)
*/
#define     NUL     '\0'
#define     SOH     '\x01'
#define     STX     '\x02'
#define     ETX     '\x03'
#define     EOT     '\x04'
#define     ENQ     '\x05'
#define     ACK     '\x06'
#define     BEL     '\x07'

#define     BS	    '\x08'
#define     HT	    '\x09'
#define     TAB     '\x09'
#define     LF	    '\x0A'
#define     VT	    '\x0B'
#define     FF	    '\x0C'
#define     CR	    '\x0D'
#define     SO	    '\x0E'
#define     SI	    '\x0F'

#define     DLE     '\x10'
#define     DC1     '\x11'	/* ^Q */
#define     CON     '\x11'	/* DC1=CON */
#define     SEP     '\x12'
#define     DC3     '\x13'
#define     COFF    '\x14'
#define     NAK     '\x15'
#define     SYN     '\x16'

#define     CAN     '\x18'
#define     SS2     '\x19'
#define     SUB     '\x1A'
#define     ESC     '\x1B'
#define     SS3     '\x1D'
#define     RS	    '\x1E'
#define     US	    '\x1F'

#define     SPC     '\x20'
#define     DEL     '\x7F'	/* DYNSEP Hard-separateur de packings */

#define     CSI     '\x9B'

/*[1] Strings versions */
#define     USstr   "\x1F"
#define     ESCstr  "\x1B"
#define     CSIstr  "\x9B"
#define     ANSI    "\x01B["


/*[1] Nomenclature ascii CEPT0
*/
#define     APU     '\x0B'
#define     APB     '\x08'
#define     APF     '\x09'
#define     APD     '\x0A'
#define     APR     '\x0D'
#define     REP     '\x12'	/* =SEP */
#define     INI     '\x13'	/* =DC3 */
#define     DCT     '\x1A'
#define     TER     '\x1C'	/* PCK_SEP separateur des bases!!!! */
#define     APH     '\x1E'
#define     APA     '\x1F'
#define     US	    '\x1F'



/*[1] Ponctuations
/*************************************/

#define     SPACE	    '\x20'
#define     ESPACE	  SPACE

#define     NL		    '\n'
#define     NEWLINE 	'\n'
#define     GRAVE	    '`'

#define     COMMA	    ','
#define     COMA	    COMMA
#define     VIRGULE	  COMMA

#define     PERIOD	    '.'
#define     SEMICOLON	    ';'
#define     COLON	    ':'

#define     APOS 	    '\''
#define     QUOTE	    APOS

#define     QUOT  	  '\"'
#define     QUOTES	  QUOT
#define     DQUOTES	  QUOT

#define     BSLASH	  '\\'
#define     FSLASH	  '/'
#define     VERTBAR	  '|'
#define     LPARENT	  '('
#define     RPARENT	  ')'
#define     LPARO     LPARENT	    
#define     RPARO     RPARENT
#define     LBRACE	  '{'
#define     RBRACE	  '}'
#define     LT  	    '<'
#define     GT  	    '>'
#define     LTAG	    LT
#define     RTAG	    GT
#define     LBRACKET	'\x5B'
#define     RBRACKET	'\x5D'

/*  ebase soft-usage comme ALT_SEP */
#define     AT        '@'
#define     AROBAS    AT
#define     CARET	    '^'
#define     TILDE	    '~'
#define     TREMA	    ''
#define     STAR    	'*'
#define     ASTERISK	STAR 
#define     PERCENT	  '%'
#define     NUMSIGN	  '#'
#define     DIESE	    NUMSIGN
#define     DOLLAR	  '$'
#define     AMPERSAND	'&'
#define     EQUAL	    '='
#define     PLUS	    '+'
#define     MINUS	    '-'
#define     TIRET	    '-'
#define     UNDERSCORE '_'
#define     UNDERLINE	 UNDERSCORE	    
#define     QUESTION	 '?'
#define     EXCLAM	   '!'
#define     EXCLAMATION	EXCLAM

/*************************************/
/*[1Q:exit]  exit
/*************************************/
#endif  /* _C_ASCII_H_*/
