/*****************************************************
  file    : c_char.h
  usage   : macros et decl de traitement de chaines
  date    : 1991 -- 
  copyleft: I.R.Maturana <irm@in3activa.com>
  autres  :
  licence : gnu - see www.gnu.org/copyleft/gpl.html
 *****************************************************/


#ifndef _C_CHAR_H_
#define _C_CHAR_H_

#include    <ctype.h>
#include    <string.h>


/*[1] Dfinition de c_Char (unsigned par dfaut)
/*    TODO : unicode support
/*-------------------------------------------------*/

typedef unsigned char	      uchar;     
typedef unsigned const char ucchar;     
typedef   signed const char	cchar;     

typedef	char*               lpstr;     
typedef	const char*         lpcstr;


//@NULLables Dfinitions de caracteres ASCII											   
#define	c_isempty(s) (!s || !*s)
#define	c_isvalid(s) (!c_isempty(s))


/*[1] macros manipulation de chaines
/*-------------------------------------------------*/
// TODO : selon locale ?
#define c_isspace   isspace
#define c_isalnum   isalnum
#define c_isalpha   isalpha
#define c_isdigit   isdigit
#define c_ispunct   ispunct

#define c_issyntax(c)	            (c_isalnum(c) || UNDERSCORE==(c) )
#define c_issyntax_period(c)      (c_issyntax(c)|| PERIOD==(c))


#define c_upper(s) _strupr(s)
#define c_lower(s) _strlwr(s)


/* Syntaxe RTF 
/*  tous les types de caracteres de "\lang1024"	
/*  Noter que isrtf() ne tient pas compte de la syntaxe d'apparition
/*  012\lang pourrait etre considr lgal
*/
#define	c_isrtf(c)	              (isalnum(c)||MINUS==c||BSLASH==c) 

// Recherche de jeux de carcateres dans une chaine: ne retourne jamais NULL
// strfindc () retourne le caractere trouv: NUL si n'existe pas (<--- Tests!)
// strfind  () retourne l'adresse du caractere, ou pointe sur \0
// stroffset() retourne l'offset du caractere dans la chaine, ou =strlen()

#define c_pos_of(s,p)	            (strcspn(((lpstr)s),(p)))		   /* offset	*/
#define c_adr_of(s,p)	            (((lpstr)s)+c_pos_of((s),(p)))         /* adresse	*/
#define c_chr_of(s,p)	            (c_adr_first_of((lpstr)s,p)[0])		   /* 1er caractere, ou NUL */

#define c_pos_not_of(s,p)	        (strspn (((lpstr)s),(p)))             /* offset	*/
#define c_adr_not_of(s,p)	        (((lpstr)s)+c_pos_not_of((s),(p)))         /* addresse	*/
#define c_chr_not_of(s,p)	        (c_pos_not_of((s),(p))[0])             /* offset	*/

#define c_adr_space(s)	          c_adr_of((s), " \t")      
#define c_pos_no_space(s)	        c_pos_not_of((s), " \t")  
#define c_adr_no_space(s)	        c_adr_not_of((s), " \t")  

// Fonctions versions
lpstr c_adr_blank(lpstr s);
int   c_pos_no_blank(lpcstr s);
#define c_adr_no_blank(s)	       ((s)+c_pos_no_blank(s))

#define c_strequ(s1,s2)	          (!strcmp((lpstr)s1,(lpstr)s2))
#define c_strnequ(s1,s2,n)        (!strcmps((lpstr)s1,(lpstr)s2,n))
#define c_striequ(s1,s2,n)        (!stricmp((lpstr)s1,(lpstr)s2))         

// Attention: retourne NULL ou l'adresse !!
#define c_adr_eol(s)	            strchr(((lpstr)s),NL)
#define c_adr_nul(s)	            strchr(((lpstr)s),0) 
#define c_adr_eos(s)	            c_adr_nul(s) 


#endif  /* _C_CHAR_H_*/
