/*****************************************************
  file    : xemcl - XEM Command Line 
  usage   : fonction main
  date    : 2001
  copyleft: I.R.Maturana <irm@in3activa.com>
  autres  :
  licence : www.gnu.org/copyleft/gpl.html
 *****************************************************/

#include <c_Xem.h>

int usage()
{
   fprintf(stderr, "\n usage:");
   fprintf(stderr, "\n xemcl [-x] [-{i,I}[n]] [-b etiqueta] archivo-entrada archivo-salida");
   fprintf(stderr, "\n (c) 2001-I.R.M");
   fprintf(stderr, "\n\n");
   fprintf(stderr, "\n -x			archivo-salida con formato XEM");
   fprintf(stderr, "\n -i[num]		atributos id='ID<num>' en elementos de raiz");
   fprintf(stderr, "\n -I[num]		atributos id='ID<num>' en todos los elementos");
   fprintf(stderr, "\n -b etiqueta  recuperar slo etiqueta <etiqueta>");
   return 2;
}

int main(int argc, char* argv[])
{
c_Xem cx;		// arborescence en memoire
c_Str inpfile;  // fichier entree
c_Str outfile;	// fichier sortie 
bool  isappend= false;	// si append mode
int	  loop;

  // parsing des options 
  // les 2 derniers params sont toujours les fichiers entree+sortie
  if( argc<3) return usage();
  for( loop= 1; loop< argc; loop++)
  {
	if( '-'!=argv[loop][0]) break;
	switch( argv[loop][1])
	{
	case 'x':				// type de sortie save()
	  cx.m_outtype= CX_XEMTYPE; 
	  break;	  
	case 'i':				// application noeuds racine
	  cx.m_withids= 1; 
	  cx.m_baseids= atoi(argv[loop]+1);	  // si \0, renvoie 0
	  break;	  
	case 'I':				// application tous les noeuds
	  cx.m_withids= 3; 
	  cx.m_baseids= atoi(argv[loop]+1);	  // si \0, renvoie 0
	  break;	  
	case 'a':				// append sur fileout
	  isappend= true; 
	  break;
	case 'b':
	  cx.m_usertag= argv[++loop]; 
	  break;
	default:
	  return usage();
	}
  }
  if( loop<argc) inpfile= argv[loop++]; else return usage();
  if( loop<argc) outfile= argv[loop++]; else return usage();
  if( loop<argc) return usage();	// trop de parametres !

  // traitement 
  try
  {					 
	if( isappend)
	{
	  cx.load(outfile);		// re-lecture du fichier 
	  cx.append(inpfile);	// ajout eliminer le node racine
	}
	else
	  cx.load(inpfile);	  // lecture du fichier 

    cx.save(outfile);	  // sortie au format spcifi
  }
  catch(...)
  {
	if( cx.errno)
	  fprintf(stderr, "ERR:%d:%s\n", cx.errno, (lpstr)cx.errstr);
	else
	  fprintf(stderr, "ERR:(unknow error)\n");
    return 2;
  }

  fprintf(stderr, "%s\n", (lpstr)cx.errstr);
  return 0;
}

/* done */